import XConteudo
import OFS
import Globals
import time
import DateTime
from AccessControl import ClassSecurityInfo
from OFS.Folder import Folder
from OFS.Cache import Cacheable

_marker = []

class XPagina ( XConteudo.XConteudo ):
    """Classe que define a XPagina."""

    meta_type = 'XPagina'
    friendly_name = 'Pgina'

    security = ClassSecurityInfo()

    security.declareProtected('Modificar Propriedades da XPagina', 'manage_PropertiesForm')
    manage_PropertiesForm = Globals.DTMLFile("dtml/editXPaginaForm", globals(), in_ZMI=1)

    security.declareProtected('Utilizar Interface de Gerenciamento do ZCoMIX','gadgetPropertiesForm')
    gadgetPropertiesForm = Globals.DTMLFile("dtml/editXPaginaForm", globals(), in_ZMI=0)

    security.declareProtected('Utilizar Interface de Gerenciamento do ZCoMIX','manage_ZPropertiesForm')
    manage_ZPropertiesForm = Globals.DTMLFile("dtml/ZTemplate", globals(), in_ZMI=0, z_conteudo='gadgetPropertiesForm')

    security.declareProtected('Modificar Propriedades da XPagina','manage_ImagesForm')
    manage_ImagesForm = Globals.DTMLFile("dtml/gadgetImages", globals(), in_ZMI=1)

    security.declareProtected('Utilizar Interface de Gerenciamento do ZCoMIX','gadgetImagesForm')
    gadgetImagesForm = Globals.DTMLFile("dtml/gadgetImages", globals(), in_ZMI=0)

    security.declareProtected('Utilizar Interface de Gerenciamento do ZCoMIX','manage_ZImagesForm')
    manage_ZImagesForm = Globals.DTMLFile("dtml/ZTemplate", globals(), in_ZMI=0, z_conteudo='gadgetImagesForm')

    def __init__(self, id, title):
        self.id = id
        self.title = title

    security.declareProtected('Modificar Propriedades da XPagina', 'manage_Properties')
    def manage_Properties(self, title, data_inicial='1970/01/01', data_final='2030/01/01',
    texto="", mostrar_no_menu_superior=0, mostrar_no_menu_esquerdo=0, mostrar_no_menu_direito=0,
    usar_structured_text=0, in_ZMI=1, REQUEST=None, *args, **kw):
        "Modifica as Propriedades do XPagina"
        self.title = title
        try: self.data_inicial = DateTime.DateTime(data_inicial).ISO()
        except: self.data_inicial = '1970/01/01'
        try: self.data_final = DateTime.DateTime(data_final).ISO()
        except: self.data_final = '2030/01/01'
        self.mostrar_no_menu_superior = mostrar_no_menu_superior
        self.mostrar_no_menu_esquerdo = mostrar_no_menu_esquerdo
        self.mostrar_no_menu_direito = mostrar_no_menu_direito
        self._texto = texto
        self._usar_structured_text = usar_structured_text
        if self.catalog_principal is not None:
                self.manage_editCataloger(self.catalog_principal)
        self.ZCacheable_invalidate()
        if REQUEST is not None:
          if in_ZMI:
            return self.manage_PropertiesForm(REQUEST, management_view='Propriedades',
                manage_tabs_message='A Pagina <strong>%s</strong> foi editada.' % self.id
                )
          else:
            return self.manage_ZPropertiesForm(REQUEST, management_view='Propriedades',
                manage_tabs_message='A Pagina <strong>%s</strong> foi editada.' % self.id
                )

Globals.default__class_init__(XPagina)

def manage_addXPagina(self, id, title, produtor='admin', data_producao='1970/01/01',
        data_inicial='1970/01/01', data_final='2030/01/01', texto="",
        mostrar_no_menu_superior=0, mostrar_no_menu_direito=0, mostrar_no_menu_esquerdo=0,
        usar_structured_text=0, REQUEST=None):
        """Cria um XPagina e o adiciona ao seu parent Folder.
        O argumento 'self' referencia o parent Folder.
        """
        pagina = XPagina(id, title)
        pagina.produtor = REQUEST.AUTHENTICATED_USER.getId()
        t = time.time()
        pagina.data_producao = DateTime.DateTime(t).ISO()
        try: pagina.data_inicial = DateTime.DateTime(data_inicial).ISO()
        except: pagina.data_inicial = '1970/01/01'
        try: pagina.data_final = DateTime.DateTime(data_final).ISO()
        except: pagina.data_final = '2030/01/01'
        pagina.mostrar_no_menu_superior = mostrar_no_menu_superior
        pagina.mostrar_no_menu_esquerdo = mostrar_no_menu_esquerdo
        pagina.mostrar_no_menu_direito = mostrar_no_menu_direito
        pagina._texto = texto
        pagina._usar_structured_text = usar_structured_text
        self._setObject(id, pagina)
        pagina = getattr(self, id)
        if self.catalog_principal is not None:
                pagina.manage_editCataloger(self.catalog_principal)
                getattr(self, self.catalog_principal).catalog_object(pagina, '/' + pagina.absolute_url(relative=1))

        if REQUEST is not None:
                return self.manage_main(self, REQUEST)

manage_addXPaginaForm = Globals.DTMLFile('dtml/addXPaginaForm', globals())
